// testdll.cpp : Defines the entry point for the application.
//

// Windows Header Files:
#include <windows.h>
#include <stdlib.h>
#include <malloc.h>
#include <memory.h>
#include <tchar.h>

typedef BOOL (__stdcall *Image2PDFShellFunc)(LPCTSTR lpInputFile, LPCTSTR lpOutputFile, LPCTSTR lpOptions);
Image2PDFShellFunc Image2PDFShell;
HMODULE	 g_hImg2PDFOCRSDK = NULL;

void GetModulePath(char *out_path,char *in_name)
{
	char *p;
	GetModuleFileName(NULL,out_path,256);
	p =strrchr(out_path,'\\');
	p[1]=0;
	strcat(out_path,in_name);
}
void FreeImg2PDFOCRSDK()
{
	if(g_hImg2PDFOCRSDK == NULL)
		return;
	FreeLibrary(g_hImg2PDFOCRSDK);
	g_hImg2PDFOCRSDK = NULL;
}
BOOL LoadImg2PDFOCRSDK()
{
	char path[_MAX_PATH];
	GetModulePath(path,"img2pdfshell.dll");
	g_hImg2PDFOCRSDK = LoadLibrary(path);
	if(g_hImg2PDFOCRSDK == NULL)
	{
		g_hImg2PDFOCRSDK = LoadLibrary("img2pdfshell.dll");
		if(g_hImg2PDFOCRSDK == NULL)
			goto Failer;
	}

	Image2PDFShell = (Image2PDFShellFunc)GetProcAddress(g_hImg2PDFOCRSDK,"Image2PDFShell");
	if(Image2PDFShell == NULL)
		goto Failer;
	return TRUE;
Failer:
	FreeImg2PDFOCRSDK(); 
	return FALSE;
}
int APIENTRY WinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPSTR     lpCmdLine,
                     int       nCmdShow)
{
	if(__argc != 3)
	{
		MessageBox(NULL,"Parameter error","Error",MB_OK);
		return 0;
	}
	if(!LoadImg2PDFOCRSDK())
	{
		MessageBox(NULL,"Can't locate 'img2pdfshell.dll' library.","Error",MB_OK);
		return 0;
	}
	Image2PDFShell(__argv[1],__argv[2],"-x 1 -b -1");
	FreeImg2PDFOCRSDK();
	MessageBox(NULL,"ConvertImageToPDF OK","OK",MB_OK);
	return 0;
}